package com.fr.plugin.beans;

import com.fr.decision.system.bean.message.MessageUrlType;
import com.fr.decision.system.bean.message.MobileMessageType;
import com.fr.plugin.entitys.OutputMyEntity;
import com.fr.schedule.base.bean.output.BaseOutputAction;
import com.fr.schedule.base.entity.AbstractScheduleEntity;
import com.fr.schedule.base.type.RunType;
import com.fr.third.fasterxml.jackson.annotation.JsonSubTypes;

@JsonSubTypes.Type(
        value = MyOutputBean.class,
        name = "Outputxxxx"
)
public class MyOutputBean extends BaseOutputAction {
    private int terminal = 64;
    private String sysKey = null;
    private String subject;
    private String content;
    private int linkOpenType;
    private String customizeLink;
    private int type;
    private String mediaId;
    private String agentId;
    private int runType;
    private int platform;
    private int messageType;
    public String getAgentId() {
        return agentId;
    }

    public int getPlatform() {
        return platform;
    }

    public void setPlatform(int platform) {
        this.platform = platform;
    }

    public int getMessageType() {
        return messageType;
    }

    public void setMessageType(int messageType) {
        this.messageType = messageType;
    }

    public void setAgentId(String agentId) {
        this.agentId = agentId;
    }

    public int getTerminal() {
        return terminal;
    }

    public void setTerminal(int terminal) {
        this.terminal = terminal;
    }

    public String getSysKey() {
        return sysKey;
    }

    public void setSysKey(String sysKey) {
        this.sysKey = sysKey;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public int getLinkOpenType() {
        return linkOpenType;
    }

    public void setLinkOpenType(int linkOpenType) {
        this.linkOpenType = linkOpenType;
    }

    public String getCustomizeLink() {
        return customizeLink;
    }

    public void setCustomizeLink(String customizeLink) {
        this.customizeLink = customizeLink;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getMediaId() {
        return mediaId;
    }

    public void setMediaId(String mediaId) {
        this.mediaId = mediaId;
    }

    public int getRunType() {
        return runType;
    }

    public void setRunType(int runType) {
        this.runType = runType;
    }
    //这里直接关联第一步的entity类
    public Class<? extends AbstractScheduleEntity> outputActionEntityClass() {
        return OutputMyEntity.class;
    }

    @Override
    public AbstractScheduleEntity createOutputActionEntity() {
        OutputMyEntity var1 = new OutputMyEntity();
        var1.setId(this.getId());
        var1.setTerminal(this.getTerminal());
        var1.setSysKey(this.getSysKey());
        var1.setSubject(this.getSubject());
        var1.setContent(this.getContent());
        var1.setLinkOpenType(this.getLinkOpenType());
        var1.setCustomizeLink(this.getCustomizeLink());
        var1.setType(this.getType());
        var1.setAgentId(this.getAgentId());
        var1.setMediaId(this.getMediaId());
        var1.setMessageType(this.getMessageType());
        var1.setPlatform(this.getPlatform());
        var1.setActionName(this.getActionName());
        var1.setResultURL(this.getResultURL());
//        var1.setRunType(this.runType());
//        var1.setExecuteByUser(this.willExecuteByUser());
        return var1;
    }

//    @Override
//    public OutputMyEntity createEntity() {
//
//    }

    public MyOutputBean() {
        this.linkOpenType = MessageUrlType.INNER.toInt();
        this.type = MobileMessageType.TEXT.toInt();
        this.runType = RunType.CLIENT_NOTIFICATION.getValue();
    }

    @Override
    public boolean willExecuteByUser() {
        return true;
    }

    @Override
    public RunType runType() {

        return RunType.CLIENT_NOTIFICATION;
    }
}
