package com.fr.plugin.beans;

import com.fr.json.JSONObject;
import com.fr.plugin.entitys.MyAgentEntity;
import com.fr.plugin.entitys.MyUserEntity;
import com.fr.schedule.base.bean.output.BaseOutputAction;
import com.fr.schedule.base.type.RunType;
import com.fr.stable.db.data.BaseDataRecord;
import com.fr.third.fasterxml.jackson.annotation.JsonSubTypes;

import java.io.Serializable;

@JsonSubTypes.Type(
        value = MyUserBean.class,
        name = "UserBean"
)
public class MyUserBean extends BaseDataRecord implements Serializable {

    private String openId;
    private String name;
    private String photoUrl;
    private String phone;
    private String jobNo;
    private String department;
    private int status;
    private String fsUserName;

    public String getFsUserName() {
        return fsUserName;
    }

    public void setFsUserName(String fsUserName) {
        this.fsUserName = fsUserName;
    }

    public MyUserEntity createEntity() {
        MyUserEntity var1=new MyUserEntity();
        var1.setId(this.getOpenId());
        var1.setStatus(this.getStatus());
        var1.setPhotoUrl(this.getPhotoUrl());
        var1.setJobNo(this.jobNo);
        var1.setPhone(this.phone);
        var1.setName(this.name);
        var1.setDepartment(this.department);
        var1.setStatus(this.status);
        var1.setOpenId(this.openId);
        var1.setFsUserName(this.fsUserName);
        return var1;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getOpenId() {
        return openId;
    }

    public void setOpenId(String openId) {
        this.openId = openId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPhotoUrl() {
        return photoUrl;
    }

    public void setPhotoUrl(String photoUrl) {
        this.photoUrl = photoUrl;
    }

    public String getJobNo() {
        return jobNo;
    }

    public void setJobNo(String jobNo) {
        this.jobNo = jobNo;
    }

    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public JSONObject createJSONConfig() {
        JSONObject var1 = JSONObject.create();
        var1.put("userid", this.getOpenId());
        var1.put("name", this.getName());
        var1.put("mobile", this.getPhone());
        var1.put("departmentName",  department);
        var1.put("fsUserName",fsUserName);
        return var1;
    }

    @Override
    public String toString() {
        return "MyUserBean{" +
                "openId='" + openId + '\'' +
                ", name='" + name + '\'' +
                ", photoUrl='" + photoUrl + '\'' +
                ", phone='" + phone + '\'' +
                ", jobNo='" + jobNo + '\'' +
                ", department='" + department + '\'' +
                ", status=" + status +
                ", fsUserName='" + fsUserName + '\'' +
                '}';
    }

/// "openId":String, //人员的openid
//            "name":String, //姓名
//            "photoUrl":String, //头像URL
//            "phone":String, //手机号码
//            "isHidePhone":String, //是否在通讯录中隐藏手机号码,0: 不隐藏; 1: 隐藏,默认为0
//            "email":String, //邮箱
//            "department":String, //组织长名称
//            "jobNo":String, //企业工号
//            "jobTitle":String, //职位
//            "gender":int, //性别,0: 不确定; 1: 男; 2: 女
//            "status":int, //状态 0: 注销，1: 正常，2: 禁用
//            "orgUserType":int //是否部门负责人 0:否， 1：是
    //        "positiveDate":String,//转正日期，格式如："2018-01-01"
}
