package com.fr.plugin.config;

import com.fr.config.ConfigContext;
import com.fr.config.DefaultConfiguration;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.stable.StringUtils;

public class MyConfig extends DefaultConfiguration {
    private static volatile MyConfig config = null;
    private Conf<String> appId = Holders.simple(StringUtils.EMPTY);
    private Conf<String> eid = Holders.simple(StringUtils.EMPTY);
    private Conf<String> secret = Holders.simple(StringUtils.EMPTY);
    private Conf<String> url = Holders.simple(StringUtils.EMPTY);
    private Conf<String> readKey = Holders.simple(StringUtils.EMPTY);
    private Conf<String> match = Holders.simple(StringUtils.EMPTY);
    private Conf<String> scanId = Holders.simple(StringUtils.EMPTY);
    private Conf<String> scanSecret = Holders.simple(StringUtils.EMPTY);

    private Conf<String> pushUrl = Holders.simple(StringUtils.EMPTY);

    private Conf<String> authUrl = Holders.simple(StringUtils.EMPTY);

    private Conf<String> accessToken = Holders.simple(StringUtils.EMPTY);
    private Conf<String> appKey = Holders.simple(StringUtils.EMPTY);
    private volatile boolean isAuthorityInited = false;
    private volatile boolean isDBAccessAvailable = false;
    private volatile boolean isThreadAlreadyStart = false;
    private Conf<String> lastSyncUserTime = Holders.simple(StringUtils.EMPTY);
    private Conf<String> lastSyncDepTime = Holders.simple(StringUtils.EMPTY);
    private Conf<String> synToken = Holders.simple(StringUtils.EMPTY);

    public static MyConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(MyConfig.class);
        }
        return config;
    }

    public String getLastSyncUserTime() {
        return lastSyncUserTime.get();
    }

    public void setLastSyncUserTime(String lastSyncUserTime) {
        this.lastSyncUserTime.set(lastSyncUserTime);
    }

    public String getLastSyncDepTime() {
        return lastSyncDepTime.get();
    }

    public void setSynToken(String token) {
        this.synToken.set(token);
    }

    public String getSynToken() {
        return synToken.get();
    }

    public void setLastSyncDepTime(String lastSyncDepTime) {
        this.lastSyncDepTime.set(lastSyncDepTime);
    }

    public String getAppId() {
        return appId.get();
    }

    public void setAppId(String appId) {
        this.appId.set(appId);
    }

    public String getEid() {
        return eid.get();
    }

    public void setEid(String eid) {
        this.eid.set(eid);
    }

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String secret) {
        this.secret.set(secret);
    }

    public String getUrl() {
        return url.get();
    }

    public void setUrl(String url) {
        this.url.set(url);
    }

    public String getReadKey() {
        return readKey.get();
    }

    public void setReadKey(String readKey) {
        this.readKey.set(readKey);
    }

    public boolean isAuthorityInited() {
        return isAuthorityInited;
    }

    public void setAuthorityInited(boolean authorityInited) {
        isAuthorityInited = authorityInited;
    }

    public boolean isDBAccessAvailable() {
        return isDBAccessAvailable;
    }

    public void setDBAccessAvailable(boolean DBAccessAvailable) {
        isDBAccessAvailable = DBAccessAvailable;
    }

    public boolean isThreadAlreadyStart() {
        return isThreadAlreadyStart;
    }

    public void setThreadAlreadyStart(boolean threadAlreadyStart) {
        isThreadAlreadyStart = threadAlreadyStart;
    }

    public String getMatch() {
        return match.get();
    }

    public void setMatch(String match) {
        this.match.set(match);
    }

    public String getScanId() {
        return scanId.get();
    }

    public void setScanId(String scanId) {
        this.scanId.set(scanId);
    }

    public String getScanSecret() {
        return scanSecret.get();
    }

    public void setScanSecret(String scanSecret) {
        this.scanSecret.set(scanSecret);
    }

    public String getAccessToken() {
        return accessToken.get();
    }

    public void setAccessToken(String accessToken) {
        this.accessToken.set(accessToken);
    }

    public String getAuthUrl() {
        return authUrl.get();
    }

    public void setAuthUrl(String authUrl) {
        this.authUrl.set(authUrl);
    }

    public String getAppKey() {
        return appKey.get();
    }

    public void setAppKey(String appKey) {
        this.appKey.set(appKey);
    }

    public String getPushUrl() {
        return pushUrl.get();
    }

    public void setPushUrl(String pushUrl) {
        this.pushUrl.set(pushUrl);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        MyConfig clone = (MyConfig) super.clone();
        clone.secret = (Conf<String>) secret.clone();
        clone.appId = (Conf<String>) appId.clone();
        clone.eid = (Conf<String>) eid.clone();
        clone.url = (Conf<String>) url.clone();
        clone.readKey = (Conf<String>) readKey.clone();
        clone.match = (Conf<String>) match.clone();

        clone.scanId = (Conf<String>) scanId.clone();
        clone.lastSyncUserTime = (Conf<String>) lastSyncUserTime.clone();
        clone.lastSyncDepTime = (Conf<String>) lastSyncDepTime.clone();
        clone.synToken = (Conf<String>) synToken.clone();
        clone.scanSecret = (Conf<String>) scanSecret.clone();
        return clone;
    }
}
