package com.fr.plugin.core;

import com.fr.log.FineLoggerFactory;
import com.fr.plugin.config.MyConfig;
import com.fr.plugin.dao.MyAgentDao;
import com.fr.plugin.dao.MyDepDao;
import com.fr.plugin.dao.MyUserDao;
import com.fr.plugin.dao.PushDao;
import com.fr.plugin.db.AbstractDBAccessProvider;
import com.fr.plugin.entitys.MyAgentEntity;
import com.fr.plugin.entitys.MyDepEntity;
import com.fr.plugin.entitys.MyUserEntity;
import com.fr.plugin.entitys.PushEntity;
import com.fr.plugin.utils.MyUtils;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;

import java.util.Timer;
import java.util.TimerTask;

public class MyCoreDBAccess extends AbstractDBAccessProvider {
    private static DBAccessor accessor;
    public static DBAccessor getAccessor() {
        return accessor;
    }
    @Override
    public DAOProvider[] registerDAO() {
        return new DAOProvider[]{
                new DAOProvider() {
                    public Class getEntityClass() {
                        return MyAgentEntity.class;
                    }

                    public Class<? extends BaseDAO> getDAOClass() {
                        return MyAgentDao.class;
                    }
                },
                new DAOProvider() {
                    public Class getEntityClass() {
                        return MyUserEntity.class;
                    }

                    public Class<? extends BaseDAO> getDAOClass() {
                        return MyUserDao.class;
                    }
                },
                new DAOProvider() {
                    public Class getEntityClass() {
                        return MyDepEntity.class;
                    }

                    public Class<? extends BaseDAO> getDAOClass() {
                        return MyDepDao.class;
                    }
                },
                new DAOProvider() {
                    public Class getEntityClass() {
                        return PushEntity.class;
                    }

                    public Class<? extends BaseDAO> getDAOClass() {
                        return PushDao.class;
                    }
                }

        };
    }

    @Override
    public void onDBAvailable(DBAccessor dbAccessor) {
        accessor = dbAccessor;
        MyConfig.getInstance().setDBAccessAvailable(true);
//        MyUtils.startSyncThread();
        Timer timer = new Timer();
        timer.schedule(new TimerTask() {
            @Override
            public void run() {
                FineLoggerFactory.getLogger().info("开始同步部门和用户数据--用户数据--线程启动");
            //    new MyStartupThred().start();
            }
        }, 2000, 60 * 60 * 1000);
    }
}
