package com.fr.plugin.core;

import com.fr.decision.authority.AuthorityContext;
import com.fr.decision.authority.event.AfterInitEvent;
import com.fr.event.EventDispatcher;
import com.fr.event.Listener;
import com.fr.plugin.beans.MyOutputBean;
import com.fr.plugin.config.MyConfig;
import com.fr.plugin.context.PluginContext;
import com.fr.plugin.entitys.OutputMyEntity;
import com.fr.plugin.observer.inner.AbstractPluginLifecycleMonitor;
import com.fr.schedule.feature.ScheduleOutputActionEntityRegister;
import com.fr.schedule.feature.event.ScheduleTaskChangeEvent;
import com.fr.schedule.feature.event.ScheduleTaskChangeInfo;
import com.fr.schedule.feature.output.OutputActionHandler;

public class MyLifeCycleMonitor extends AbstractPluginLifecycleMonitor {
    @Override
    public void afterRun(PluginContext pluginContext) {
        this.registerOutputHandler();
        this.addScheduleTableRelation();
        AuthorityContext.getInstance().dispatchAfterInitEvent(new AfterInitEvent() {
            public void run() {
                MyConfig.getInstance().setAuthorityInited(true);
            }
        });
    }

    private void registerOutputHandler() {
        OutputActionHandler.registerHandler(new MyOutputActionHandler(), MyOutputBean.class.getName());
    }

    private void addScheduleTableRelation() {
        ScheduleOutputActionEntityRegister.getInstance().addClass(OutputMyEntity.class);
    }

    private void removeScheduleTableRelation() {
        ScheduleOutputActionEntityRegister.getInstance().removeClass(OutputMyEntity.class);
    }

    @Override
    public void beforeStop(PluginContext pluginContext) {
        this.removeScheduleTableRelation();
    }
}
