package com.fr.plugin.entitys;

import com.fr.plugin.beans.MyOutputBean;
import com.fr.schedule.base.entity.AbstractScheduleEntity;
import com.fr.schedule.base.entity.output.BaseOutputActionEntity;
import com.fr.stable.db.entity.TableAssociation;
import com.fr.third.javax.persistence.Column;
import com.fr.third.javax.persistence.Entity;
import com.fr.third.javax.persistence.Table;

@Entity
@Table(
        name = "fine_xxxx_output"
)
@TableAssociation(
        associated = true
)
public class OutputMyEntity extends AbstractScheduleEntity {
    private static final String COLUMN_TERMINAL = "terminal";
    private static final String COLUMN_AGENTID = "agentId";
    private static final String COLUMN_SUBJECT = "subject";
    private static final String COLUMN_CONTENT = "content";
    private static final String COLUMN_LINK_OPEN_TYPE = "linkOpenType";
    private static final String COLUMN_CUSTOMIZE_LINK = "customizeLink";
    private static final String COLUMN_TYPE = "type";
    private static final String COLUMN_MEDIA_ID = "mediaId";
    @Column(
            name = "terminal"
    )
    private int terminal = 518;

    @Column(
            name = "messageType"
    )
    private int messageType = 1;
    @Column(
            name = "platform"
    )
    private int platform = 1;
    @Column(
            name = "agentId"
    )
    private String agentId = null;
    @Column(
            name = "subject",
            length = 65536
    )

    private String subject;
    @Column(
            name = "actionName",
            nullable = false
    )
    private String actionName = null;
    @Column(
            name = "content",
            length = 65536
    )
    private String content;
    @Column(
            name = "linkOpenType"
    )
    private int linkOpenType = -1;
    @Column(
            name = "customizeLink",
            length = 65536
    )
    private String customizeLink;
    @Column(
            name = "resultURL",
            length = 1000
    )
    private String resultURL = null;
    @Column(
            name = "outputId"
    )
    private String outputId = null;

    @Column(
            name = "type"
    )
    private int type;
    @Column(
            name = "mediaId"
    )
    private String mediaId;

    @Column(
            name = "sysKey"
    )
    private String sysKey;


    public OutputMyEntity() {
    }

    public int getMessageType() {
        return messageType;
    }

    public void setMessageType(int messageType) {
        this.messageType = messageType;
    }

    public int getPlatform() {
        return platform;
    }

    public void setPlatform(int platform) {
        this.platform = platform;
    }

    public MyOutputBean createBean() {
        MyOutputBean var1 = new MyOutputBean();
        var1.setId(this.getId());
        var1.setSysKey(this.getSysKey());
        var1.setTerminal(this.getTerminal());
        var1.setSubject(this.getSubject());
        var1.setContent(this.getContent());
        var1.setLinkOpenType(this.getLinkOpenType());
        var1.setCustomizeLink(this.getCustomizeLink());
        var1.setType(this.getType());
        var1.setMediaId(this.getMediaId());
        var1.setActionName(this.getActionName());
        var1.setAgentId(this.getAgentId());
        var1.setPlatform(this.getPlatform());
        var1.setMessageType(this.getMessageType());
        var1.setResultURL(this.getResultURL());
        return var1;
    }
    public String getActionName() {
        return this.actionName;
    }

    public void setActionName(String var1) {
        this.actionName = var1;
    }

    public String getSysKey() {
        return sysKey;
    }

    public void setSysKey(String sysKey) {
        this.sysKey = sysKey;
    }

    public String getResultURL() {
        return this.resultURL;
    }

    public void setResultURL(String var1) {
        this.resultURL = var1;
    }


    public String getAgentId() {
        return this.agentId;
    }

    public void setAgentId(String var1) {
        this.agentId = var1;
    }

    public int getTerminal() {
        return this.terminal;
    }

    public void setTerminal(int var1) {
        this.terminal = var1;
    }

    public String getSubject() {
        return this.subject;
    }

    public void setSubject(String var1) {
        this.subject = var1;
    }

    public String getContent() {
        return this.content;
    }

    public void setContent(String var1) {
        this.content = var1;
    }

    public int getLinkOpenType() {
        return this.linkOpenType;
    }

    public void setLinkOpenType(int var1) {
        this.linkOpenType = var1;
    }

    public String getCustomizeLink() {
        return this.customizeLink;
    }

    public void setCustomizeLink(String var1) {
        this.customizeLink = var1;
    }

    public int getType() {
        return this.type;
    }

    public void setType(int var1) {
        this.type = var1;
    }

    public String getMediaId() {
        return this.mediaId;
    }

    public void setMediaId(String var1) {
        this.mediaId = var1;
    }
}
