package com.fr.plugin.utils;

import com.fr.stable.StringUtils;
import com.fr.third.fasterxml.jackson.core.JsonGenerator;
import com.fr.third.fasterxml.jackson.databind.JsonNode;
import com.fr.third.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;
import java.io.StringWriter;

public class JsonUtils {
    private JsonUtils() {
    }

    public static JsonNode parseToJsonNode(String json) throws IOException {
        ObjectMapper objectMapper = new ObjectMapper();
        if (StringUtils.isBlank(json)) {
            return objectMapper.createObjectNode();
        } else {
            try {
                return objectMapper.readTree(json);
            } catch (Exception var3) {
                throw new IOException(var3);
            }
        }
    }

    public static String toJsonString(Object obj) {
        ObjectMapper objectMapper = new ObjectMapper();
        StringWriter stringWriter = new StringWriter();
        JsonGenerator jsonGenerator = null;
        try {
            jsonGenerator = objectMapper.getJsonFactory().createJsonGenerator(stringWriter);
            objectMapper.writeValue(jsonGenerator, obj);
        } catch (IOException var5) {
        }

        return stringWriter.toString();
    }

}