package com.fr.plugin.utils;

import com.fr.json.JSONObject;
import com.fr.plugin.PluginLicense;
import com.fr.plugin.PluginLicenseManager;
import com.fr.plugin.config.MyTimingTaskConfig;
import com.fr.plugin.constant.Week;
import com.fr.plugin.core.MyCoreDBAccess;
import com.fr.plugin.core.MyStartupThred;
import com.fr.plugin.dao.MyAgentDao;
import com.fr.plugin.entitys.MyAgentEntity;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.Restriction;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

public class MyUtils {
    public static boolean isLicenseAvailable() {
        PluginLicense var0 = PluginLicenseManager.getInstance().getPluginLicenseByID("com.fr.plugin.meixin.10");
        return var0.isAvailable();
    }



    public static JSONObject createSuccessResponseJSONObject() {
        JSONObject var0 = JSONObject.create();
        var0.put("errorCode", 0);
        var0.put("status", "success");
        return var0;
    }


    public static List getAgentsSortedByTimeStamp() throws Exception {
        return MyCoreDBAccess.getAccessor().runQueryAction(new DBAction<List<MyAgentEntity>>() {
            public List<MyAgentEntity> run(DAOContext var1) throws Exception {
                QueryCondition queryCondition = QueryFactory.create();
                return var1.getDAO(MyAgentDao.class).find(queryCondition
                        .addSort("id", true));
            }
        });

    }

    public static MyAgentEntity getAgentById(String id) throws Exception {
        return MyCoreDBAccess.getAccessor().runQueryAction(new DBAction<MyAgentEntity>() {
            public  MyAgentEntity run(DAOContext var1) throws Exception {
                QueryCondition queryCondition = QueryFactory.create();
                return var1.getDAO(MyAgentDao.class).findOne(queryCondition.addRestriction(RestrictionFactory.eq("id",id)));
            }
        });
    }

    public static void startUpUserSyncThread() {
//        new MyStartupThred().start();
    }

}
