package com.fr.plugin.utils;

import com.fr.third.springframework.util.DigestUtils;

import java.util.Arrays;
import java.util.Map;
import java.util.Set;

public class SignUtils {


    public static String getSign(Map<String, Object> map, String secret) {
//        TreeMap<String, Object> map = new TreeMap<String, Object>(parms);
//        StringBuilder query = new StringBuilder();
//        Set<String> set = map.keySet();
//        query.append(secret);
//        for (String key : set) {
//            String value = String.valueOf(map.get(key));
//            query.append(key).append(value);
//        }
//        query.append(secret);
//        return DigestUtils.md5DigestAsHex(query.toString().getBytes());
        // 第一步：检查参数是否已经排序
        String[] keys = map.keySet().toArray(new String[0]);
        Arrays.sort(keys);

        // 第二步：把所有参数名和参数值串在一起
        StringBuilder query = new StringBuilder();

        query.append(secret);
        for (String key : keys) {
            String value = String.valueOf(map.get(key));
            query.append(key).append(value);
        }
        query.append(secret);

        // 第三步：计算签名
        String sign = DigestUtils.md5DigestAsHex(query.toString().getBytes());
        return sign;
    }

    public static String pinParam(Map<String, Object> parms) {
        StringBuilder query = new StringBuilder();
        Set<String> set = parms.keySet();
        for (String key : set) {
            String value = String.valueOf(parms.get(key));
            query.append(key).append("=").append(value).append("&");
        }

        return query.substring(0, query.length() - 1);
    }
}
