package com.fr.plugin.web.hander;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.PluginLicense;
import com.fr.plugin.PluginLicenseManager;
import com.fr.plugin.beans.MyAgentBean;
import com.fr.plugin.entitys.MyAgentEntity;
import com.fr.plugin.utils.MyUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Iterator;
import java.util.List;

public class GetAgentHandler extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/xxx/agent";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        int var3 = WebUtils.getHTTPRequestIntParameter(httpServletRequest, "startIdx", -1);
        int var4 = WebUtils.getHTTPRequestIntParameter(httpServletRequest, "count", -1);
        List var5 = MyUtils.getAgentsSortedByTimeStamp();
        JSONArray var6 = new JSONArray();
        JSONObject var7 = MyUtils.createSuccessResponseJSONObject();
        if (var3 == -1 && var4 == -1) {
            Iterator var11 = var5.iterator();
            while(var11.hasNext()) {
                MyAgentEntity var12 = (MyAgentEntity)var11.next();
                var6.put(var12.createBean(new MyAgentBean()).toJSONObject());
            }
        } else if (var3 > -1 && var4 > -1) {
            int var8 = Math.min(var4 + var3, var5.size());

            for(int var9 = var3; var9 < var8; ++var9) {
                MyAgentEntity var10 = (MyAgentEntity)var5.get(var9);
                var6.put(var10.createBean(new MyAgentBean()).toJSONObject());
            }
        }

        var7.put("total", var5.size());
        var7.put("agentList", var6);
        WebUtils.flushSuccessMessageAutoClose(httpServletRequest, httpServletResponse, var7);
    }
}
