package com.fr.plugin.web.hander;

import com.fr.decision.base.util.UUIDUtil;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.ComparatorUtils;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.core.MyCoreDBAccess;
import com.fr.plugin.dao.MyAgentDao;
import com.fr.plugin.entitys.MyAgentEntity;
import com.fr.plugin.utils.MyAgentUtils;
import com.fr.stable.StringUtils;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Iterator;
import java.util.List;

public class SaveAgentHandler   extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.POST;
    }

    @Override
    public String getPath() {
        return "/xxx/agent";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        JSONArray agentArr = new JSONArray(WebUtils.getHTTPRequestParameter(httpServletRequest, "agentArr"));
        JSONArray resp = new JSONArray();

        for(int i = 0; i < agentArr.length(); ++i) {
            String agent_uid = agentArr.optJSONObject(i).optString("id");
            final boolean agent_exist = StringUtils.isNotBlank(agent_uid);
            if (StringUtils.isEmpty(agent_uid)) {
                agent_uid = UUIDUtil.generate();
            }

            String agent_name = agentArr.optJSONObject(i).optString("agentName");
            String agent_id = agentArr.optJSONObject(i).optString("sysKey");//公共号编号
            String secret = agentArr.optJSONObject(i).optString("secret");


            List<MyAgentEntity> agent_lists =   MyCoreDBAccess.getAccessor().runQueryAction(new DBAction<List<MyAgentEntity>>() {
                public List<MyAgentEntity> run(DAOContext content) throws Exception {
                    return   content.getDAO(MyAgentDao.class) .find(QueryFactory.create());
                }
            });
            Iterator var13 = agent_lists.iterator();
            MyAgentEntity temp_agent;
            while(var13.hasNext()) {
                temp_agent = (MyAgentEntity)var13.next();
                if (ComparatorUtils.equals(temp_agent.getAgentName(), agent_name) && !agent_exist) {
                    WebUtils.flushFailureMessageAutoClose(httpServletRequest, httpServletResponse, 11205018, "存在同名服务号");
                    return;
                }

                if (agent_exist && ComparatorUtils.equals(temp_agent.getAgentName(), agent_name) && !ComparatorUtils.equals(agent_uid, temp_agent.getId())) {
                    WebUtils.flushFailureMessageAutoClose(httpServletRequest, httpServletResponse, 11205018, "服务号已经存在");
                    return;
                }
            }

//            String var16 = MyAgentUtils.getAgentIdBySecret(agent_id, secret);
            //插入或更新这个公共号，全看id
            temp_agent = new MyAgentEntity().id(agent_uid)
                    .agentName(agent_name)
                    .sysKey(agent_id)
                    .secret(secret);
            MyAgentEntity finalVar1 = temp_agent;
            MyCoreDBAccess.getAccessor().runDMLAction(new DBAction<MyAgentEntity>() {
                public MyAgentEntity run(DAOContext var1) throws Exception {
                    if (agent_exist) {
                         var1.getDAO(MyAgentDao.class).update(finalVar1);
                    } else {
                         var1.getDAO(MyAgentDao.class).add(finalVar1);
                    }

                    return null;
                }
            });
//

            resp.put(agent_uid);
        }

        JSONObject var15 = JSONObject.create();
        var15.put("errorCode", 0);
        var15.put("agentIds", resp);
        WebUtils.flushSuccessMessageAutoClose(httpServletRequest, httpServletResponse, var15);
    }
}
