package com.fr.plugin.web.hander.member;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.config.MyConfig;
import com.fr.plugin.core.MyCorpManager;
import com.fr.plugin.utils.MyUtils;
import com.fr.third.org.apache.commons.lang3.math.NumberUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GetMatch extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/xxx/match/method";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        JSONObject jsonObject = MyUtils.createSuccessResponseJSONObject();
        MyConfig config = MyConfig.getInstance();
        if (config != null) {
            String match = config.getMatch();
            int c = NumberUtils.isDigits(match) ? Integer.parseInt(match) : 1;
            jsonObject.put("matchingFsWay", c);
        }
        WebUtils.flushSuccessMessageAutoClose(httpServletRequest, httpServletResponse, jsonObject);
    }
}

