package com.fr.plugin.web.hander.member;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.beans.MyDepBean;
import com.fr.plugin.beans.MyUserBean;
import com.fr.plugin.core.MyUserSyncManager;
import com.fr.plugin.utils.MyUtils;
import com.fr.stable.StringUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Iterator;
import java.util.List;

public class GetMemberHandler extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.POST;
    }

    @Override
    public String getPath() {
        return "/xxx/dep/member";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest request, HttpServletResponse response) throws Exception {
        int startIdx = WebUtils.getHTTPRequestIntParameter(request, "startIdx", 0);
        int count = WebUtils.getHTTPRequestIntParameter(request, "count", 10);
        String keyword = WebUtils.getHTTPRequestParameter(request, "keyword");
//        String var7 = WebUtils.getHTTPRequestParameter(request, "secret");
        String depId = WebUtils.getHTTPRequestParameter(request, "depId");
        List<MyUserBean> users;
        Long size = 0L;
        try{
            if (StringUtils.isNotEmpty(keyword)) {
                users = this.getSelectedUser(keyword, startIdx, count);
                size = this.countSelectedUser(keyword);
            } else {
                MyDepBean var10 = new MyDepBean();
                var10.setId("");
                var10.setDepName(depId);
                users = this.getSelectedDepartmentUser(var10, startIdx, count);
                size = this.countSelectedDepartmentUser(var10);
            }
            JSONObject jsonObject = toUserResultJo(users, size);
            JSONObject responseJSONObject = MyUtils.createSuccessResponseJSONObject();
            responseJSONObject.put("userList", jsonObject);
            WebUtils.flushSuccessMessageAutoClose(request, response, responseJSONObject);
        }catch (Exception e){
            e.printStackTrace(response.getWriter());
        }
    }

    private Long countSelectedDepartmentUser(MyDepBean bean) throws Exception {
        return MyUserSyncManager.getInstance().countDepartmentUserList(bean.getDepName());
    }

    private List<MyUserBean> getSelectedDepartmentUser(MyDepBean bean, int start, int count) throws Exception {
        return MyUserSyncManager.getInstance().getDepartmentUserList(bean.getDepName(), start, count);

    }

    private List<MyUserBean> getSelectedUser(String key, int start, int count) throws Exception {
        return MyUserSyncManager.getInstance().getUserList(key, start, count);
    }

    private Long countSelectedUser(String key) throws Exception {
        return MyUserSyncManager.getInstance().countUserList(key);
    }

    public static JSONObject toUserResultJo(List<MyUserBean> users, Long var1) throws Exception {
        JSONObject var2 = JSONObject.create();
        JSONArray var3 = JSONArray.create();

        JSONObject var6;
        for (Iterator var4 = users.iterator(); var4.hasNext(); var3.put(var6)) {
            MyUserBean var5 = (MyUserBean) var4.next();
            var6 = var5.createJSONConfig();
        }

        var2.put("total", var1);
        var2.put("users", var3);
        return var2;
    }
}
