package com.fr.plugin.web.hander.member;

import com.fr.base.ServerConfig;
import com.fr.decision.authority.data.User;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.v10.login.LoginService;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.json.JSONObject;
import com.fr.plugin.config.MyConfig;
import com.fr.stable.StringUtils;
import com.fr.third.jodd.util.Base64;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;
import java.io.StringWriter;

public class LanlingLogin extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/xxx/lanlin/login";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String token = httpServletRequest.getParameter("token");
        String callBack = httpServletRequest.getParameter("callBack");
        JSONObject jsonObject = new JSONObject();
        MyConfig instance = MyConfig.getInstance();
        if (StringUtils.isBlank(token)) {
            jsonObject.put("status", -1);
            jsonObject.put("message", "未找到token");
            com.fr.web.utils.WebUtils.flushSuccessMessageAutoClose(httpServletRequest, httpServletResponse, jsonObject);
            return;
        }
        try {
            token = Base64.decodeToString(token);
            JSONObject json = new JSONObject(token);
            String username = json.getString("username");
            User user = UserService.getInstance().getUserByUserName(username);
            if (user != null) {
                LoginService.getInstance().login(httpServletRequest, httpServletResponse, username, "", "");
                if (StringUtils.isNotBlank(callBack)) {
                    httpServletResponse.sendRedirect(callBack);
                    return;
                }
                String servletName = ServerConfig.getInstance().getServletName();
                String url = instance.getUrl() + servletName;
                httpServletResponse.sendRedirect(url);
            }
        } catch (Exception e) {
            e.printStackTrace();
            StringWriter writer = new StringWriter();
            PrintWriter printWriter = new PrintWriter(writer);
            e.printStackTrace(printWriter);
            String s = writer.getBuffer().toString();
            WebUtils.printAsString(httpServletResponse,s);
        }
    }
}

