package com.fr.plugin.web.hander.member;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.plugin.config.MyConfig;
import com.fr.plugin.core.MyCoreDBAccess;
import com.fr.plugin.dao.MyUserDao;
import com.fr.plugin.entitys.MyUserEntity;
import com.fr.plugin.utils.MyUtils;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

public class SaveRelation extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.POST;
    }

    @Override
    public String getPath() {
        return "/xxx/user/relation";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String opendId = WebUtils.getHTTPRequestParameter(httpServletRequest, "weiXinUser");
        String fsUser = WebUtils.getHTTPRequestParameter(httpServletRequest, "fsUser");

        MyUserEntity entity = MyCoreDBAccess.getAccessor().runQueryAction(new DBAction<MyUserEntity>() {
            public MyUserEntity run(DAOContext content) throws Exception {
                QueryCondition queryCondition = QueryFactory.create();
                queryCondition.addRestriction(RestrictionFactory.eq("openId", opendId));
                return content.getDAO(MyUserDao.class).findOne(queryCondition);
            }
        });
        entity.setFsUserName(fsUser);
        MyCoreDBAccess.getAccessor().runDMLAction(new DBAction<MyUserEntity>() {
            public MyUserEntity run(DAOContext content) throws Exception {
                content.getDAO(MyUserDao.class).update(entity);
                return null;
            }
        });
        JSONObject responseJSONObject = MyUtils.createSuccessResponseJSONObject();
        responseJSONObject.put("id", entity.getId());
        WebUtils.flushSuccessMessageAutoClose(httpServletRequest, httpServletResponse, responseJSONObject);
    }
}

