package com.fr.plugin.web.hander;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.plugin.core.MyCoreDBAccess;
import com.fr.plugin.dao.PushDao;
import com.fr.plugin.entitys.PushEntity;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class pushBeanHandler extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/xxx/pushBean";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String id = httpServletRequest.getParameter("id");
        PushEntity entity = MyCoreDBAccess.getAccessor().runQueryAction(new DBAction<PushEntity>() {
            @Override
            public PushEntity run(DAOContext daoContext) throws Exception {
                return daoContext.getDAO(PushDao.class).findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("pushId", id)));
            }
        });
        if (entity != null) {
            String url = entity.getUrl();
            httpServletResponse.sendRedirect(url);
        }
        WebUtils.printAsString(httpServletResponse, "未找到这个推送");
    }
}
